
_delay_ms:

;digitalclock.c,25 :: 		void delay_ms(int ms)
;digitalclock.c,28 :: 		for(i = ms; i > 0; i--) delay_ms(1);
	MOVF       FARG_delay_ms_ms+0, 0
	MOVWF      R1+0
	MOVF       FARG_delay_ms_ms+1, 0
	MOVWF      R1+1
L_delay_ms0:
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__delay_ms19
	MOVF       R1+0, 0
	SUBLW      0
L__delay_ms19:
	BTFSC      STATUS+0, 0
	GOTO       L_delay_ms1
	MOVLW      7
	MOVWF      R12+0
	MOVLW      125
	MOVWF      R13+0
L_delay_ms3:
	DECFSZ     R13+0, 1
	GOTO       L_delay_ms3
	DECFSZ     R12+0, 1
	GOTO       L_delay_ms3
	MOVLW      1
	SUBWF      R1+0, 1
	BTFSS      STATUS+0, 0
	DECF       R1+1, 1
	GOTO       L_delay_ms0
L_delay_ms1:
;digitalclock.c,29 :: 		}
L_end_delay_ms:
	RETURN
; end of _delay_ms

_timer_init:

;digitalclock.c,30 :: 		void timer_init()       //initialisation of timer1 module
;digitalclock.c,32 :: 		TMR1H=TMR1L=0;         //clearing 16 bit register to start from first itself
	CLRF       TMR1L+0
	MOVF       TMR1L+0, 0
	MOVWF      TMR1H+0
;digitalclock.c,33 :: 		T1CON.T1CKPS1=1;      //choosing the 1:4 prescalr
	BSF        T1CON+0, 5
;digitalclock.c,34 :: 		T1CON.T1CKPS0=0;
	BCF        T1CON+0, 4
;digitalclock.c,35 :: 		T1CON.T1OSCEN=0;    //Don"t use LP oscillator
	BCF        T1CON+0, 3
;digitalclock.c,36 :: 		T1CON.TMR1CS=0;     //Use microcontroller internal clock for counting the pulse
	BCF        T1CON+0, 1
;digitalclock.c,37 :: 		PIE1.TMR1IE=1;      //Interrupt enable pin of the timer1 module
	BSF        PIE1+0, 0
;digitalclock.c,38 :: 		T1CON.TMR1ON=1;     //Enable timer1 ON
	BSF        T1CON+0, 0
;digitalclock.c,39 :: 		INTCON.PEIE=1;      //Enable peripheral interrupt enable bit
	BSF        INTCON+0, 6
;digitalclock.c,40 :: 		INTCON.GIE=1;       //Enable Global interrupt enable bit
	BSF        INTCON+0, 7
;digitalclock.c,41 :: 		}
L_end_timer_init:
	RETURN
; end of _timer_init

_Interrupt_ISR:

;digitalclock.c,43 :: 		void Interrupt_ISR()
;digitalclock.c,45 :: 		if(PIR1.TMR1IF==1)   //check really interrupt is fired by the timer1 module
	BTFSS      PIR1+0, 0
	GOTO       L_Interrupt_ISR4
;digitalclock.c,47 :: 		count++;              //increase count by one(count++=(count=count+1))
	MOVF       _count+0, 0
	ADDLW      1
	MOVWF      R0+0
	MOVLW      0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _count+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _count+0
	MOVF       R0+1, 0
	MOVWF      _count+1
;digitalclock.c,48 :: 		PIR1.TMR1IF=0;       //clear the interrupt flag
	BCF        PIR1+0, 0
;digitalclock.c,49 :: 		}
L_Interrupt_ISR4:
;digitalclock.c,50 :: 		}
L_end_Interrupt_ISR:
	RETURN
; end of _Interrupt_ISR

_displayclock:

;digitalclock.c,52 :: 		void displayclock()
;digitalclock.c,56 :: 		if(hr<10)
	MOVLW      128
	XORWF      _hr+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__displayclock23
	MOVLW      10
	SUBWF      _hr+0, 0
L__displayclock23:
	BTFSC      STATUS+0, 0
	GOTO       L_displayclock5
;digitalclock.c,58 :: 		LCD_out(1,5,"0");          //move the cursor to 1st row 5th column
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      5
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_digitalclock+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,60 :: 		Lcd_Out(1,6,hr);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      6
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _hr+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,62 :: 		}
	GOTO       L_displayclock6
L_displayclock5:
;digitalclock.c,65 :: 		LCD_out(1,5,hr);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      5
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _hr+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,67 :: 		}
L_displayclock6:
;digitalclock.c,68 :: 		LCD_out(1,7,":");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_digitalclock+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,71 :: 		if(minu<10)
	MOVLW      128
	XORWF      _minu+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__displayclock24
	MOVLW      10
	SUBWF      _minu+0, 0
L__displayclock24:
	BTFSC      STATUS+0, 0
	GOTO       L_displayclock7
;digitalclock.c,73 :: 		LCD_out(1,8,"0");          //move the cursor to 1st row 8th column
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr3_digitalclock+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,75 :: 		Lcd_Out(1,9,minu);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      9
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _minu+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,77 :: 		}
	GOTO       L_displayclock8
L_displayclock7:
;digitalclock.c,80 :: 		LCD_out(1,8,minu);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _minu+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,82 :: 		}
L_displayclock8:
;digitalclock.c,83 :: 		LCD_out(1,10,":");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr4_digitalclock+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,86 :: 		if(sec<10)
	MOVLW      128
	XORWF      _sec+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__displayclock25
	MOVLW      10
	SUBWF      _sec+0, 0
L__displayclock25:
	BTFSC      STATUS+0, 0
	GOTO       L_displayclock9
;digitalclock.c,88 :: 		LCD_out(1,11,"0");          //move the cursor to 1st row 11th column
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr5_digitalclock+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,90 :: 		Lcd_Out(1,12,sec);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      12
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _sec+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,92 :: 		}
	GOTO       L_displayclock10
L_displayclock9:
;digitalclock.c,95 :: 		LCD_out(1,11,sec);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _sec+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;digitalclock.c,97 :: 		}
L_displayclock10:
;digitalclock.c,98 :: 		}
L_end_displayclock:
	RETURN
; end of _displayclock

_main:

;digitalclock.c,99 :: 		int main()
;digitalclock.c,101 :: 		LCD_init();  //Initialise the LCD display
	CALL       _Lcd_Init+0
;digitalclock.c,103 :: 		hr=18;
	MOVLW      18
	MOVWF      _hr+0
	MOVLW      0
	MOVWF      _hr+1
;digitalclock.c,104 :: 		minu=34;
	MOVLW      34
	MOVWF      _minu+0
	MOVLW      0
	MOVWF      _minu+1
;digitalclock.c,105 :: 		sec=10;
	MOVLW      10
	MOVWF      _sec+0
	MOVLW      0
	MOVWF      _sec+1
;digitalclock.c,107 :: 		timer_init(); //initialise the timer1
	CALL       _timer_init+0
;digitalclock.c,108 :: 		displayclock();
	CALL       _displayclock+0
;digitalclock.c,109 :: 		while(1)
L_main11:
;digitalclock.c,111 :: 		if(count==19)
	MOVLW      0
	XORWF      _count+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main27
	MOVLW      19
	XORWF      _count+0, 0
L__main27:
	BTFSS      STATUS+0, 2
	GOTO       L_main13
;digitalclock.c,113 :: 		sec++;
	MOVF       _sec+0, 0
	ADDLW      1
	MOVWF      R0+0
	MOVLW      0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _sec+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _sec+0
	MOVF       R0+1, 0
	MOVWF      _sec+1
;digitalclock.c,114 :: 		count=0;
	CLRF       _count+0
	CLRF       _count+1
;digitalclock.c,115 :: 		change=1;
	MOVLW      1
	MOVWF      _change+0
	MOVLW      0
	MOVWF      _change+1
;digitalclock.c,116 :: 		}
L_main13:
;digitalclock.c,117 :: 		if(sec==60)
	MOVLW      0
	XORWF      _sec+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main28
	MOVLW      60
	XORWF      _sec+0, 0
L__main28:
	BTFSS      STATUS+0, 2
	GOTO       L_main14
;digitalclock.c,119 :: 		minu++;
	MOVF       _minu+0, 0
	ADDLW      1
	MOVWF      R0+0
	MOVLW      0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _minu+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _minu+0
	MOVF       R0+1, 0
	MOVWF      _minu+1
;digitalclock.c,120 :: 		sec=0;
	CLRF       _sec+0
	CLRF       _sec+1
;digitalclock.c,121 :: 		change=1;
	MOVLW      1
	MOVWF      _change+0
	MOVLW      0
	MOVWF      _change+1
;digitalclock.c,122 :: 		}
L_main14:
;digitalclock.c,123 :: 		if(minu==60)
	MOVLW      0
	XORWF      _minu+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main29
	MOVLW      60
	XORWF      _minu+0, 0
L__main29:
	BTFSS      STATUS+0, 2
	GOTO       L_main15
;digitalclock.c,125 :: 		hr++;
	MOVF       _hr+0, 0
	ADDLW      1
	MOVWF      R0+0
	MOVLW      0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _hr+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _hr+0
	MOVF       R0+1, 0
	MOVWF      _hr+1
;digitalclock.c,126 :: 		minu=0;
	CLRF       _minu+0
	CLRF       _minu+1
;digitalclock.c,127 :: 		change=1;
	MOVLW      1
	MOVWF      _change+0
	MOVLW      0
	MOVWF      _change+1
;digitalclock.c,128 :: 		}
L_main15:
;digitalclock.c,129 :: 		if(hr==24)
	MOVLW      0
	XORWF      _hr+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main30
	MOVLW      24
	XORWF      _hr+0, 0
L__main30:
	BTFSS      STATUS+0, 2
	GOTO       L_main16
;digitalclock.c,131 :: 		hr=0;
	CLRF       _hr+0
	CLRF       _hr+1
;digitalclock.c,132 :: 		minu=0;
	CLRF       _minu+0
	CLRF       _minu+1
;digitalclock.c,133 :: 		sec=0;
	CLRF       _sec+0
	CLRF       _sec+1
;digitalclock.c,134 :: 		}
L_main16:
;digitalclock.c,136 :: 		if(change)
	MOVF       _change+0, 0
	IORWF      _change+1, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
;digitalclock.c,138 :: 		displayClock();
	CALL       _displayclock+0
;digitalclock.c,139 :: 		change = 0;
	CLRF       _change+0
	CLRF       _change+1
;digitalclock.c,140 :: 		}
L_main17:
;digitalclock.c,141 :: 		}
	GOTO       L_main11
;digitalclock.c,142 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
